> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create SCIM Connection

> Create a new SCIM connection for an organization

export const action_0 = "create"

export const resource_0 = "stytch.scim"

<Note>
  **RBAC Enforced API**

  If a Member Session is passed in the Authorization headers, Stytch will enforce that the Member has permission to take the **{action_0} Action** on the **{resource_0} Resource** prior to honoring the request.

  To learn more, see the [RBAC guide](/multi-tenant-auth/enterprise-ready/rbac).
</Note>


## OpenAPI

````yaml POST /v1/b2b/scim/{organization_id}/connection
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/b2b/scim/{organization_id}/connection:
    post:
      tags:
        - B2B Scim
      summary: Create
      description: Create a new SCIM Connection.
      operationId: api_b2b_scim_v1_b2b_scim_connection_Create
      parameters:
        - name: organization_id
          in: path
          required: true
          schema:
            type: string
            description: >-
              Globally unique UUID that identifies a specific Organization. The
              `organization_id` is critical to perform operations on an
              Organization, so be sure to preserve this value. You may also use
              the organization_slug or organization_external_id here as a
              convenience.
          description: >-
            Globally unique UUID that identifies a specific Organization. The
            `organization_id` is critical to perform operations on an
            Organization, so be sure to preserve this value. You may also use
            the organization_slug or organization_external_id here as a
            convenience.
        - name: X-Stytch-Member-Session
          in: header
          required: false
          description: >-
            A Stytch session that can be used to run the request with the given
            member's permissions.
          schema:
            type: string
        - name: X-Stytch-Member-SessionJWT
          in: header
          required: false
          description: >-
            A Stytch Session JSON Web Token (JWT) that can be used to run the
            request with the given member's permissions.
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/api_b2b_scim_v1_b2b_scim_connection_CreateRequest
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api_b2b_scim_v1_b2b_scim_connection_CreateResponse
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/b2b/scim/{organization_id}/connection
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              organization_id: "organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931",
              display_name: "Example SCIM connection",
            };

            const options = {
              authorization: {
                session_token: '${sessionToken}',
              },
            };

            client.SCIM.Connection.Create(params, options)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/b2b/scim/{organization_id}/connection\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/b2bstytchapi\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/scim/connection\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/methodoptions\"\n)\n\nfunc main() {\n\tclient, err := b2bstytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &connection.CreateParams{\n\t\tOrganizationID: \"organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931\",\n\t\tDisplayName:    \"Example SCIM connection\",\n\t}\n\n\toptions := &connection.CreateParamsOptions{\n\t\tAuthorization: methodoptions.Authorization{\n\t\t\tSessionToken: \"${sessionToken}\",\n\t\t},\n\t}\n\n\tresp, err := client.SCIM.Connection.Create(context.Background(), params, options)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: >-
            // POST /v1/b2b/scim/{organization_id}/connection

            package com.example;


            import com.stytch.java.b2b.models.scimconnection.CreateRequest;

            import
            com.stytch.java.b2b.models.scimconnection.CreateRequestOptions;

            import com.stytch.java.b2b.StytchB2BClient;

            import com.stytch.java.common.methodoptions.Authorization;

            import com.stytch.java.common.StytchResult;


            public class Main {
                public static void main(String[] args) {
                    StytchB2BClient.configure("${projectId}", "${secret}");

                    CreateRequest params = new CreateRequest();
                    params.setOrganizationId("organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931");
                    params.setDisplayName("Example SCIM connection");

                    CreateRequestOptions options = new CreateRequestOptions();
                    Authorization authorization = new Authorization();
                    authorization.setSessionToken("${sessionToken}");
                    options.setAuthorization(authorization);

                    Object result = StytchB2BClient.getSCIM().getConnection().create(params, options);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: >
            // POST /v1/b2b/scim/{organization_id}/connection

            package com.example


            import com.stytch.java.b2b.StytchB2BClient

            import com.stytch.java.b2b.models.scimconnection.CreateRequest

            import
            com.stytch.java.b2b.models.scimconnection.CreateRequestOptions

            import com.stytch.java.common.methodoptions.Authorization


            fun main() {
                StytchB2BClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchB2BClient.scim.connection.create(
                            CreateRequest(
                                organizationId = "organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931",
                                displayName = "Example SCIM connection",
                            ),
                            CreateRequestOptions(
                                Authorization(
                                    sessionToken = "${sessionToken}",
                                ),
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/b2b/scim/{organization_id}/connection
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              organization_id: "organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931",
              display_name: "Example SCIM connection",
            };

            const options = {
              authorization: {
                session_token: '${sessionToken}',
              },
            };

            client.scim.connection.create(params, options)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->scim->connection->create([
                'organization_id' => 'organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931',
                'display_name' => 'Example SCIM connection',
            ], [
                    'authorization' => ['session_token' => '${sessionToken}'],

            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/b2b/scim/{organization_id}/connection
            from stytch import B2BClient
            from stytch.b2b.models.scim_connection import CreateRequestOptions
            from stytch.shared.method_options import Authorization

            client = B2BClient(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.scim.connection.create(
                organization_id="organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931",
                display_name="Example SCIM connection",
                method_options=CreateRequestOptions(
                    authorization=Authorization(
                        session_token="${sessionToken}",
                    ),
                ),
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # POST /v1/b2b/scim/{organization_id}/connection
            require 'stytch'

            client = StytchB2B::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.scim.connection.create(
              organization_id: "organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931",
              display_name: "Example SCIM connection",
              method_options: StytchB2B::SCIM::Connection::CreateRequestOptions.new(
                authorization: Stytch::MethodOptions::Authorization.new(session_token: '${sessionToken}')
              )
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/b2b/scim/{organization_id}/connection
            use stytch::b2b::client::Client;
            use stytch::b2b::scim_connection::CreateRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.scim.connection.create(
                    CreateRequest{
                        organization_id: "organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931",
                        display_name: Some(String::from("Example SCIM connection")),
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/b2b/scim/{organization_id}/connection
            curl --request POST \
              --url https://test.stytch.com/v1/b2b/scim/organization-test-07971b06-ac8b-4cdb-9c15-63b17e653931/connection \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -H "X-Stytch-Member-Session: ${sessionToken}" \
              -d '{
                "display_name": "Example SCIM connection"
              }'
components:
  schemas:
    api_b2b_scim_v1_b2b_scim_connection_CreateRequest:
      type: object
      properties:
        display_name:
          type: string
          description: A human-readable display name for the connection.
        identity_provider:
          $ref: >-
            #/components/schemas/api_b2b_scim_v1_scim_connection_CreateRequestIdentityProvider
      description: Request type
    api_b2b_scim_v1_b2b_scim_connection_CreateResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
        connection:
          $ref: '#/components/schemas/api_b2b_scim_v1_SCIMConnectionWithToken'
          description: >-
            The [SCIM Connection
            Object](https://stytch.com/docs/b2b/api/scim-connection-object).
      required:
        - request_id
        - status_code
    api_b2b_scim_v1_scim_connection_CreateRequestIdentityProvider:
      type: string
      enum:
        - generic
        - okta
        - microsoft-entra
        - cyberark
        - jumpcloud
        - onelogin
        - pingfederate
        - rippling
    api_b2b_scim_v1_SCIMConnectionWithToken:
      type: object
      properties:
        organization_id:
          type: string
          description: >-
            Globally unique UUID that identifies a specific Organization. The
            `organization_id` is critical to perform operations on an
            Organization, so be sure to preserve this value. You may also use
            the organization_slug or organization_external_id here as a
            convenience.
        connection_id:
          type: string
          description: The ID of the SCIM connection.
        status:
          type: string
          description: >-
            The status of the connection. The possible values are deleted or
            active.
        display_name:
          type: string
          description: A human-readable display name for the connection.
        identity_provider:
          type: string
          description: >-
            Name of the IdP. Enum with possible values: `okta`,
            `microsoft-entra`, `cyberark`, `jumpcloud`, `onelogin`,
            `pingfederate`, `rippling` or `generic`. 


            Specifying a known provider allows Stytch to handle any
            provider-specific logic, such as automatically appending
            `?aadOptscim062020` to the returned BaseURL for `microsoft-entra`
            SCIM Connections to [enable the SCIM 2.0 compliant
            flag](https://learn.microsoft.com/en-us/entra/identity/app-provisioning/application-provisioning-config-problem-scim-compatibility#scim-20-compliance-issues-and-status).
        base_url:
          type: string
          description: >-
            The URL supplied to the Identity Provider (IdP) alongside the bearer
            token enabling access to Stytch's SCIM API endpoints
        bearer_token:
          type: string
          description: >-
            The token supplied to the Identity Provider (IdP) alongside the base
            URL that grants access to Stytch's SCIM API endpoints. It should be
            included in HTTP authorization headers. This field is supplied only
            on creation of the SCIM connection.
        scim_group_implicit_role_assignments:
          type: array
          items:
            $ref: >-
              #/components/schemas/api_b2b_scim_v1_SCIMGroupImplicitRoleAssignments
          description: >-
            An array of SCIM group implicit role assignments. Each object in the
            array must contain a `group_id` and a `role_id`.
        bearer_token_expires_at:
          type: string
          description: The bearer token expiry time.
      required:
        - organization_id
        - connection_id
        - status
        - display_name
        - identity_provider
        - base_url
        - bearer_token
        - scim_group_implicit_role_assignments
    api_b2b_scim_v1_SCIMGroupImplicitRoleAssignments:
      type: object
      properties:
        role_id:
          type: string
          description: The ID of the role.
        group_id:
          type: string
          description: The ID of the group.
        group_name:
          type: string
      required:
        - role_id
        - group_id
        - group_name
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````